<template>
  <div class="root-container">
    <div class="dashboard">
      <div class="switches">
        <div class="switches--draw"
             :class="{switchActive: drawing}"
             @click="drawing = !drawing">Draw</div>
        <div class="switches--list"
             :class="{switchActive: !drawing}"
             @click="drawing = !drawing">Consult</div>
      </div>
      <div v-if="drawing" class="dashboard--editor-container">
        <app-draw-controls class="dashboard--editor-draw-controls"
                           :addCircle="() => newCircle(false)"
                           :exportTags="exportData"
                           :isUploading="isUploading"
                           :retrieveData="synchronizeData"
                           :isSynchronizing="isSynchronizing"
                           :deleteCurrentTag="removeCurrentTag"
                           :imagePosition="imagePos"
                           :numberOfChanges="numberOfChanges"></app-draw-controls>
        <div class="dashboard--editor-video"
             @click.ctrl.exact="() => newCircle(true)"
             @click.ctrl.alt="removeCurrentTag">
          <app-video-canvas class="dashboard--editor-video-canvas"
                            ref="videoCanvas"
                            :stageHeight="height"
                            :stageWidth="width"
                            :strokeWidth="defaultStrokeWidth"
                            :circles="circles"
                            :selectedCircle="selectedCircle"
                            @circleSelectionChanged="selectedCircle = $event"
                            @circleChanged="updateCircleAfterTransform($event)"
                            :textTags="textTags"
                            @textChanged="updateTextTagAfterTransform($event)"
                            @updateTextValue="updateTextValue($event)"
                            :deleteCurrentTag="removeCurrentTag"
                            :subImages="subImages"
                            @subImageChanged="updateSubImages($event)"
                            :imagesToTag="transformedImages"
                            :imageNbr="imagePos"></app-video-canvas>
          <app-video-controls
            :nextImage="nextImage"
            :previousImage="previousImage"></app-video-controls>
        </div>
      </div>
      <div v-if="!drawing" class="dashboard--drawlist-container">
        <app-draw-list :circles="circles"
                       :textTags="textTags"
                       :subImages="subImages"></app-draw-list>
      </div>
    </div>
  </div>
</template>

<script>
  import DrawControls from "./DrawControls";
  import DrawList from "./DrawList";
  import VideoControls from "./VideoControls";
  import VideoCanvas from "./VideoCanvas";

  const width = 700;
  const height = 500;

  export default {
    name: 'Dashboard',
    components: {
        appDrawControls: DrawControls,
        appDrawList: DrawList,
        appVideoControls: VideoControls,
        appVideoCanvas: VideoCanvas
    },
    data () {
      return {
        width : width,
        height: height,
        drawing: true,
        circles: [],
        defaultStrokeWidth: 5,
        initialPosition: {x: width/2, y: height/2, radius: 50},
        isUploading: false,
        isSynchronizing: false,
        selectedCircle: '',
        images: [
          require('../assets/images/todd-quackenbush-IClZBVw5W5A-unsplash.jpg'),
          require('../assets/images/naassom-azevedo-Q_Sei-TqSlc-unsplash.jpg'),
          require('../assets/images/catherina-schurmann-fDBGvnAIQOo-unsplash.jpg'),
          require('../assets/images/wells-chan-dGlw3ZvytP4-unsplash.jpg'),
          require('../assets/images/oleg-magni-_6Uy6nwVohE-unsplash.jpg'),
        ],
        transformedImages: [new window.Image()],
        imagePos: 0,
        textTags: [],
        subImages: [],
        numberOfChanges: 0
      }
    },

    methods: {
      newCircle(fromKeyboard) {
        let xPos = this.initialPosition.x;
        let yPos = this.initialPosition.y;
        if (fromKeyboard) {
          xPos = event.layerX;
          yPos = event.layerY;
        }
        const newId = Math.round(Math.random() * 10000).toString();
        this.circles.push({
          id: newId,
          name: newId,
          x: xPos,
          y: yPos,
          radius: this.initialPosition.radius,
          rotation: 0,
          scaleX: 1,
          scaleY: 1,
          stroke: 'goldenrod',
          strokeWidth: this.defaultStrokeWidth,
          draggable: true,
          linkedImage: this.imagePos
        });
        this.textTags.push({
          id: '-'+newId,
          text: 'Enter tag here',
          x: xPos + this.initialPosition.radius - 20,
          y: yPos + this.initialPosition.radius,
          linkedImage: this.imagePos
        });
        this.subImages.push({
          id: newId,
          imageURL: '../assets/logo.png',
          linkedImage: this.imagePos
        });
        const retrievedSubImageAtCreation = this.$refs.videoCanvas.retrieveImage({
            x: () => xPos,
            y: () => yPos,
            rotation: () => 0,
            radius: () => this.initialPosition.radius,
            scaleX: () => 1,
            scaleY: () => 1
        });
        this.updateSubImageAtCreation(newId, {imageURL: retrievedSubImageAtCreation})
        this.numberOfChanges = this.numberOfChanges + 1;
      },
      exportData() {
        if (this.imagePos !== 0) {
          this.isUploading = true;
          this.$http.patch('https://video-tagger-backend.firebaseio.com/data.json', {
                    circles: this.circles,
                    tags: this.textTags,
                    subImages: this.subImages
                  })
                  .then(() => {
                    this.isUploading = false;
                    this.numberOfChanges = 0;
                  }, error => {
                    console.log(error);
                    this.isUploading = false;
                  });
        }
      },
      synchronizeData() {
        this.isSynchronizing = true;
        this.$http.get('https://video-tagger-backend.firebaseio.com/data.json', )
                .then(response => {
                  if (response.body) {
                    this.circles = response.body.circles || [];
                    this.textTags = response.body.tags || [];
                    this.subImages = response.body.subImages || [];
                  }
                  this.isSynchronizing = false;
                  this.numberOfChanges = 0;
                }, error => {
                  console.log(error);
                  this.isSynchronizing = false;
                });
      },
      removeCurrentTag() {
        this.circles = this.circles.filter(item => item.name !== this.selectedCircle);
        this.textTags = this.textTags.filter(item => item.id !== "-"+this.selectedCircle);
        this.subImages = this.subImages.filter(item => item.id !== this.selectedCircle);
        this.selectedCircle = '';
        this.numberOfChanges = this.numberOfChanges + 1;
      },
      nextImage() {
        if (this.imagePos === this.transformedImages.length-1) {
          this.imagePos = 0;
        } else {
          this.imagePos = this.imagePos + 1;
        }
      },
      previousImage() {
        if (this.imagePos === 0) {
          this.imagePos = this.transformedImages.length-1;
        } else {
          this.imagePos = this.imagePos - 1;
        }
      },
      updateCircleAfterTransform(event) {
        const circle = this.circles.filter(item => item.name === this.selectedCircle);
        let oldCircle, newCircle;
        if (circle.length > 0) {
          oldCircle = circle[0];
          newCircle = {
            ...oldCircle,
            x: event.x,
            y: event.y,
            scaleX: event.scaleX,
            scaleY: event.scaleY,
            radius: event.radius,
            rotation: event.rotation,
            strokeWidth: event.strokeWidth,
          };
          this.circles = this.circles.filter(item => item.name !== this.selectedCircle);
          this.circles.push(newCircle);
          this.numberOfChanges = this.numberOfChanges + 1;
        }
      },
      updateTextTagAfterTransform(event) {
        const circle = this.circles.filter(item => item.name === this.selectedCircle);
        if (circle.length > 0) {
          const text = this.textTags.filter(item => item.id === "-"+circle[0].id);
          let oldText, newText;
          if (text.length > 0) {
            oldText = text[0];
            newText = {
              ...oldText,
              x: event.x + circle[0].radius*circle[0].scaleX - 20*circle[0].scaleX,
              y: event.y + circle[0].radius*circle[0].scaleY
            };
          }
          this.textTags = this.textTags.filter(item => item.id !== "-"+circle[0].id);
          this.textTags.push(newText);
        }
      },
      updateTextValue(event) {
        const text = this.textTags.filter(item => item.id === event.id);
        let oldText, newText;
        if (text.length > 0) {
          oldText = text[0];
          newText = {
            ...oldText,
            text: event.text
          };
        }
        this.textTags = this.textTags.filter(item => item.id !== event.id);
        this.textTags.push(newText);
        this.numberOfChanges = this.numberOfChanges + 1;
      },
      updateSubImages(event) {
        const subImage = this.subImages.filter(item => item.id === this.selectedCircle);
        let oldSubImage, newSubImage;
        if (subImage.length > 0) {
          oldSubImage = subImage[0];
          newSubImage = {
            ...oldSubImage,
            imageURL: event.imageURL
          };
        }
        this.subImages = this.subImages.filter(item => item.id !== this.selectedCircle);
        this.subImages.push(newSubImage);
      },
      updateSubImageAtCreation(circleId, subImageArg) {
        const subImage = this.subImages.filter(item => item.id === circleId);
        let oldSubImage, newSubImage;
        if (subImage.length > 0) {
          oldSubImage = subImage[0];
          newSubImage = {
            ...oldSubImage,
            imageURL: subImageArg.imageURL
          };
        }
        this.subImages = this.subImages.filter(item => item.id !== circleId);
        this.subImages.push(newSubImage);
      },
    },
    created() {
      this.images.forEach(image => {
        const transformedImage = new window.Image();
        transformedImage.src = image;
        while(transformedImage.height > this.height) {
          transformedImage.height = transformedImage.height / 1.2;
          transformedImage.width = transformedImage.width / 1.2;
        }
        transformedImage.onload = () => {
          // set image only when it is loaded
          this.transformedImages.push(transformedImage);
        };
      });
      this.synchronizeData();
    }
  }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
  .root-container {
    width: 100%;
  }
  .switches {
    position: absolute;
    top: -15px;
    display: flex;
    flex-flow: row;
    justify-content: flex-end;
    align-items: center;
  }
  @media (max-width: 899px) {
    .switches {
      width: 100%;
      padding-right: 70px;
    }
  }
  @media (min-width: 900px) {
    .switches {
      margin-left: 50px;
      width: 710px;
    }
  }
  .switches--draw {
    padding: 5px;
    margin-right: 10px;
    cursor: pointer;
  }
  .switches--list {
    padding: 5px;
    cursor: pointer;
  }
  .switches--draw:hover, .switches--list:hover, .switchActive {
    color: goldenrod;
  }
  .dashboard {
    position: relative;
    display: flex;
    flex-flow: column;
    justify-content: center;
    align-items: center;
    /*background-color: #2c3e50;*/
    margin: auto;
    width: 100%;
    height: 580px;
    min-height: 580px;
  }
  .dashboard--editor-container {
    display: flex;
    flex-flow: row;
    justify-content: space-between;
    /* background-color: firebrick; */
  }
  .dashboard--editor-video {
    display: flex;
    flex-flow: column;
    justify-content: space-between;
    align-items: center;
    /*background-color: greenyellow;*/
  }
  .dashboard--editor-draw-controls {
    height: 300px;
    margin-right: 15px;
    /*background-color: cornflowerblue;*/
  }
  .dashboard--drawlist-container {
    /*background-color: violet;*/
    height: 500px;
    max-height: 500px;
    width: 100%;
  }
  .dashboard--editor-video-canvas {
    border: 5px solid;
    margin-bottom: 15px;
    width: 100%;
    height: 100%;
  }

</style>
